//////////////////////////////////////////////////////////////////////////// 
// Image_Processing_toolbox_2
//
// Copyright (c) by S. Parua Biswas, CDAC, Kolkata.  2013
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function iptchecknargin(low, high, numInputs, function_name)
    if numInputs < low then
        msgId = sprintf('Images:%s:tooFewInputs', function_name);
        if low == 1 then
            msg1 = sprintf('Function %s expected at least 1 input argument', convstr(function_name, 'u'));
        else
            msg1 = sprintf('Function %s expected at least %d input arguments', convstr(function_name, 'u'), low);
        end
        
        if numInputs == 1 then
            msg2 = 'but was called instead with 1 input argument.';
        else
            msg2 = sprintf('but was called instead with %d input arguments.', numInputs);
        end
        
        error(msgId, '%s\n%s', msg1, msg2);
        
    elseif numInputs > high
        msgId = sprintf('Images:%s:tooManyInputs', function_name);
        
        if high == 1 then
            msg1 = sprintf('Function %s expected at most 1 input argument', convstr(function_name, 'u'));
        else
            msg1 = sprints('Function %s expected at most %d input arguments', convstr(function_name, 'u'), high);
            
        end
        
        if numInputs == 1 then
            msg2 = 'but was called instead with 1 input argument.';
        else
            msg2 = sprintf('but was called instead with %d input arguments.', numInputs);
        end
        
        error(msgId, '%s\n%s', msg1, msg2);        
    end
    
endfunction