//////////////////////////////////////////////////////////////////////////// 
// Image_Processing_toolbox_2
//
// Copyright (c) by S. Parua Biswas, CDAC, Kolkata.  2013
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function [P,r] = radon(I,theta,n)

    //RADON Radon transform.
    // The RADON function computes the Radon transform, which is the projection of the image intensity along a radial line oriented at a specific angle.
//    ilib_mex_build('libmexradonc',['radon','radonc','cmex'],'radonc.c',[],'Makelib','','','');
//    exec('loader.sce');
    
    [lhs,rhs]=argn(0);
    if rhs==0 then
        error('Wrong number of input arguments.');
    end
    mfilename='radon';
    iptchecknargin(1,3,rhs,mfilename);
    
    if(rhs < 2)
        theta = 0:179;
    end
 
    [P,r] = radonc(double(I),theta);
    
    if (rhs ==3) & (size(P,1) ~=n) then
        new_r = linspace(min(r), max(r), n)';
        P = interp1(r(:), P, new_r(:), '*linear');
        P = P*length(r) / length(new_r);
        r = new_r;
    end
        
endfunction



