//////////////////////////////////////////////////////////////////////////// 
// Image_Processing_toolbox_2
//
// Copyright (c) by S. Parua Biswas, CDAC, Kolkata.  2013
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function B = rot90(A,k)
    // ROT90 Rotate matrix 90 degrees counterclockwise.
    
    if ~ismatrix(A) then
        error(message('MATLAB:rot90:SizeA'));
    end
    [lhs,rhs]=argn(0);
    
    if rhs ==1 then
        k = 1;
    else
        if ~isscalar(k) then
            error(message('MATLAB:rot90:kNonScalar'));
        end
        k = rem(k,4);
        if (k<0) then
            k = k+4;
        end        
    end
    
    if (k == 1) then
        B = A(:,$:-1:1);
        B = B.';
    elseif (k==2) then
        B = A($:-1:1,$:-1:1);
    elseif (k==3) then
        B = A.';
        B = B(:,$:-1:1);    
    else
        B = A;
    end    
     
endfunction

///////////////////////////
function flag = ismatrix(a)
    [m n]=size(a);
    if (m>=1 & n>=1) then
        flag = %T;
    else
        flag = %F;
    end
    
endfunction