//////////////////////////////////////////////////////////////////////////// 
// Image_Processing_toolbox_2
//
// Copyright (c) by S. Parua Biswas, CDAC, Kolkata.  2013
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function ii = strmatch(str1,str2,flag)
    //strmatch finds possible matches for strings.
    [lhs,rhs]=argn(0);
    if (rhs<2) then
        error('Not enough input aurgument');
    end
    
    [m,n] = size(str2);
    str2=reshape_array(str2,(m*n),1);
    [m,n] = size(str2);

    
    num=0;
    for outer = 1:m
        if NumOfEle(str2(outer,1))>num then
            num=NumOfEle(str2(outer,1));            
        end
    end
    n = num;

  //    n = length(str2(1,:))
    len_str = NumOfEle(str1);
    
    if (rhs==3) then 
        ExactMatch = %T;
        if type(flag)~=10 then
            
            warning('The third aurgument to strmatch is invalid');
        elseif ~strcmpi(flag,'exact') then
            warning('Use flag ''exact''');
        end
    else
        ExactMatch = %F;
    end
//    disp(ExactMatch)
    
    // For empty str1 or str2.
    if (len_str==0) then
        str1 = reshape_array(str1,1,len_str);
        
    end
    if n==0 then
        str2 = reshape_array(str2,max(m,1),n);
        [m,n] = size(str2);
        n = length(str2(1,:))
    end

    if len_str>n then
        ii = [];
        
    else
        if ((ExactMatch~=%F) & (len_str<n)) then
            
            [str_m str_n] = size(str1);
            str_n = length(str1(1,:))
            if str_n ~= len_str then
                error('strmatch: InvalidShape');
            else
                null = char(0)
                space=' ';
                if ~isempty(str2) & mtlb_any(str2(:,$)==null) then
                    str1 = [str1 null(ones(1,n-len_str))];
                else
                    str1 = [str1 space(ones(1,n-len_str))];
                end
                len_str = n;    
               
            end
            
        end
 
        mask = ones(m,1);
            
        for outer = 1:m
            for inner = 1:len_str
     
                temp_str=str2(outer);
               if part(temp_str,[inner:inner]) ~= part(str1,inner:inner) then
               
                    mask(outer) = %F;
         //      part(mask,outer:outer) = %F;
                    
                    break;                    
                end       
       
            end //inner for
        end // outer for
    
        ii = find(mask);        
    end   

endfunction

//////////////////////////////
//Count number of element

function y = NumOfEle(x)
    if (type(x)~=1 & type(x)~=10) then
        error('Input array must be of character type');
    end
    [lhs,rhs]=argn(0);
    if rhs~=1 then
        error('Wrong number of input aurguments');        
    end
    [m n]=size(x);
    len_x=length(x(1,:));
       
//      y = 0;
    count_element=0;
//    
    for i = 1:m
        for j = 1:len_x
           count_element=count_element+1;
        end
    end
    y = count_element;
endfunction